module G5IntegrationsUpdatable
  class LocationSetting < ActiveRecord::Base
    include G5IntegrationsUpdatable::FirstClassProperties
    include G5IntegrationsUpdatable::FindOrCreateFromFeed

    validates :uid, :urn, presence: true
    validates :urn, :urn, presence: true

    INVENTORY    = 'inventory'
    LEAD_RESERVATION = 'lead_reservation'
    LEAD_INQUIRY   = 'lead_inquiry'
    LEAD_RESERVATION_WITH_FEE = 'lead_reservation_with_fee'
    LEAD_SYNCHRONIZE = 'lead_synchronize'

    scope :by_strategy_type, -> (vendor_strategy) { where(strategy_type: vendor_strategy) }
    scope :by_inventory, -> { by_strategy_type(INVENTORY) }
    scope :by_lead_reservation, -> { by_strategy_type(LEAD_RESERVATION) }
    scope :by_lead_reservation_with_fee, -> { by_strategy_type(LEAD_RESERVATION_WITH_FEE) }
    scope :by_lead_inquiry, -> { by_strategy_type(LEAD_INQUIRY) }
    scope :by_lead_synchronize, -> { by_strategy_type(LEAD_SYNCHRONIZE) }

    def to_param
      urn
    end
  end
end
