class AddVendorStrategyToLocationSettings < ActiveRecord::Migration
  def change
    add_column :g5_integrations_updatable_location_settings, :strategy_type, :string
    add_index :g5_integrations_updatable_location_settings, :strategy_type, name: 'index_strategy_type_on_location_settings'

    G5IntegrationsUpdatable::LocationSetting.reset_column_information
    G5IntegrationsUpdatable::LocationSetting.all.each do |location_setting|
      location_setting.update_attributes(strategy_type: location_setting.vendor_action == 'inventory' ? 'inventory' : 'lead_reservation')
    end

    remove_column :g5_integrations_updatable_location_settings, :vendor_action
  end
end
