module G5IntegrationsUpdatable
  class FeedFetcher
    def initialize(uri)
      @uri = uri
    end

    def process
      response = HTTParty.get(@uri, {query:   {access_token: access_token},
                                     headers: {'Content-Type' => 'application/json',
                                               'Accept' => 'application/json'}})

      case response.code.to_i
        when 200
          JSON.parse(response.body).values.first
        when 404
          raise G5IntegrationsUpdatable::RecordNotFoundException.new("Couldn't find record at URL '#{@uri}'")
        else
          raise G5IntegrationsUpdatable::Error.new("I got an unexpected response code '#{response.code}'")
      end
    end

    def access_token
      @access_token ||= G5AuthenticationClient::Client.new.get_access_token
    end
  end
end