module G5IntegrationsUpdatable
  class FeedProcessor
    attr_accessor :feed_url

    def initialize(params={})
      self.feed_url = params[:feed_url]
    end

    class << self
      def load_all_settings(all_uri)
        result_hash = G5IntegrationsUpdatable::FeedFetcher.new(all_uri).process
        G5IntegrationsUpdatable::LocationSetting.transaction do
          find_or_create_all result_hash
        end
      end

      def destroy_existing(feed_array)
        existing = G5IntegrationsUpdatable::LocationSetting.where(client_urn: feed_array.collect { |feed| feed['client_urn'] })
        existing.destroy_all
      end

      def find_or_create_all(feed_array)
        destroy_existing(feed_array)
        feed_array.each do |location_setting_hash|
          G5IntegrationsUpdatable::LocationSetting.find_or_create_from_feed(location_setting_hash)
        end
      end
    end

    def process
      self.class.find_or_create_all feed_hash_array
    end

    private
    def feed_hash_array
      G5IntegrationsUpdatable::FeedFetcher.new(self.feed_url).process
    end
  end
end