FactoryGirl.define do
  factory :location_setting, class: G5IntegrationsUpdatable::LocationSetting do
    sequence :uid do |n|
      "http://client/location-setting#{n}"
    end
    sequence :urn do |n|
      "location-setting-urn-#{n}"
    end
  end

  factory :inventory_location_setting, parent: :location_setting do
    strategy_type { G5IntegrationsUpdatable::LocationSetting::INVENTORY }
    job_frequency_in_minutes 5
  end

  factory :lead_reservation_location_setting, parent: :location_setting do
    strategy_type { G5IntegrationsUpdatable::LocationSetting::LEAD_RESERVATION }
  end

  factory :lead_synchronize_location_setting, parent: :location_setting do
    strategy_type { G5IntegrationsUpdatable::LocationSetting::LEAD_SYNCHRONIZE }
  end

  factory :lead_reservation_with_fee_location_setting, parent: :location_setting do
    strategy_type { G5IntegrationsUpdatable::LocationSetting::LEAD_RESERVATION_WITH_FEE }
  end

  factory :lead_inquiry_location_setting, parent: :location_setting do
    strategy_type { G5IntegrationsUpdatable::LocationSetting::LEAD_INQUIRY }
  end

end
